---------------------------------------------------------------------------
--
-- Licensed Materials - Property of IBM
-- 5724-T05,5724-T06
--
-- (C) Copyright IBM Corp. 2008. All Rights Reserved.
--
-- US Government Users Restricted Rights - Use, duplication or
-- disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
---------------------------------------------------------------------------
-- (#) ./base/db/Oracle8i/softalarm/saext/saext_kpi_tab.sql BL_core_schema_8.0.5_8.0.5.5.09_20081029  193433
-- (#) 
--

--
-- SAEXT KPI cache table, with monitoring
--
CREATE TABLE saext_kpi_tab
(
   tstamp		DATE	NOT NULL,
   sa_id		INTEGER	NOT NULL,
   instance_id		INTEGER	NOT NULL,
   correlation_task_id  INTEGER DEFAULT 0 NOT NULL,
   exclude		CHAR(1)	DEFAULT 'N' NOT NULL,
   value		FLOAT		NOT NULL,
   CONSTRAINT pk_saext_kpi_tab PRIMARY KEY (tstamp, sa_id, instance_id),
   CONSTRAINT exclude_chk CHECK (exclude IN ('N', 'Y'))
)
ORGANIZATION INDEX
PARTITION BY RANGE (tstamp)
(
   PARTITION P2008060100 VALUES LESS THAN (TO_DATE('20080601', 'YYYYMMDD'))
)
TABLESPACE traffic_jumbo MONITORING;
