---------------------------------------------------------------------------
--
-- Licensed Materials - Property of IBM
-- 5724-T05,5724-T06
--
-- (C) Copyright IBM Corp. 2003,2008. All Rights Reserved.
--
-- US Government Users Restricted Rights - Use, duplication or
-- disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
---------------------------------------------------------------------------
-- (#) metadata_saext_patch.sql BL_core_schema_8.0.5_8.0.5.5.06_20081022
--
PROMPT
PROMPT Adding extSoftAlarm subclass...
DECLARE
   l_count PLS_INTEGER;
   l_saext VARCHAR2(20) := 'extSoftAlarm';
BEGIN
   
   SELECT count(*)
   INTO l_count
   FROM subclass_table
   WHERE lower(name)=lower(l_saext);
   
   -- SAEXT
   IF (l_count = 0) THEN
	 
      INSERT INTO subclass_table (id, class_id, name, past_part_func)
         SELECT subclass_table_seq.NEXTVAL, 
                id, 
                l_saext, 
                'saext_pm.past_part_func'
         FROM class_table ct
         WHERE LOWER(ct.name)='part maint';
    
      INSERT INTO subclass_map (subclass_id, object_id)
         SELECT id, part_table_id
         FROM subclass_table st, part_tables pt
         WHERE st.name=l_saext
         AND UPPER(pt.table_name) ='SAEXT_KPI_TAB';

      COMMIT;

   END IF;

END;
/

-- These used sqlldr and data files. So we call directly
-- sa_aggregator
BEGIN
   INSERT INTO sa_aggregator( id, class, name, description )
   VALUES( 4, 'E', 'STDDEV-I', 'External STDDEV-I' );
EXCEPTION
   WHEN dup_val_on_index THEN
      NULL;
END;
/

BEGIN
   INSERT INTO sa_aggregator( id, class, name, description )
   VALUES( 5, 'E', 'STDDEV-II', 'External STDDEV-II' );
EXCEPTION
   WHEN dup_val_on_index THEN
      NULL;
END;
/

-- sa_time_range
BEGIN
   INSERT INTO sa_time_range( id, class, description, time_range_key )
   VALUES( 6, 'E', 'External Evaluation Algorithm', 'External Evaluation Algorithm' );
EXCEPTION
   WHEN dup_val_on_index THEN
      NULL;
END;
/

COMMIT;

