---------------------------------------------------------------------------
--
-- Licensed Materials - Property of IBM
-- 5724-T05,5724-T06
--
-- (C) Copyright IBM Corp. 2003,2008. All Rights Reserved.
--
-- US Government Users Restricted Rights - Use, duplication or
-- disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
---------------------------------------------------------------------------
--
set timing on;
set serveroutput on size 1000000;
set lines 200;

DECLARE
   doNotRemove INTEGER := 1;
BEGIN
   BEGIN
      -- Back out part maint only if 8.0.5.0 is only revision left
      SELECT count(*)
        INTO doNotRemove
        FROM component_version v
       WHERE v.revision LIKE '8.0.5.%'
         AND v.revision NOT LIKE '8.0.5.0'
         AND v.component_id =
             (SELECT component_id
                FROM component c
               WHERE UPPER(c.component_type) = 'CORE')
         AND v.component_version_id !=
             (SELECT MAX(component_version_id)
                FROM component_version v2
               WHERE v2.component_id =
                     (SELECT component_id
                        FROM component c
                       WHERE UPPER(c.component_type) = 'CORE')
                 AND v2.revision LIKE '8.0.5.%');

    EXCEPTION WHEN NO_DATA_FOUND THEN
       doNotRemove := 0;

    END;

   IF doNotRemove != 0 THEN
      dbms_output.put_line('PART_MAINT tables up to date');
      RETURN;
   END IF;

   dbms_output.put_line('Downgrading PART_MAINT tables');
   run_sql('drop table part_tablespaces cascade constraints');
   
   run_sql('ALTER TABLE part_tables DROP CONSTRAINT part_tables_move_par_ck');
   run_sql('ALTER TABLE part_tables DROP CONSTRAINT part_tables_stats_par_ck');
   run_sql('ALTER TABLE part_tables DROP COLUMN move_parallelism_degree');
   run_sql('ALTER TABLE part_tables DROP COLUMN stats_parallelism_degree');

   run_sql('ALTER TABLE part_task DROP COLUMN move_parallelism_degree');
   run_sql('ALTER TABLE part_task DROP COLUMN stats_parallelism_degree');

END;
/

