---------------------------------------------------------------------------
--
-- Licensed Materials - Property of IBM
-- 5724-T05,5724-T06
--
-- (C) Copyright IBM Corp. 2003,2008. All Rights Reserved.
--
-- US Government Users Restricted Rights - Use, duplication or
-- disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
---------------------------------------------------------------------------
-- (#) saext_schema_patch.sql BL_core_schema_8.0.5_8.0.5.5.06_20081022
--

@ install/db/Oracle8i/scheduler/saext_queue_admin/CreateQueuePack.sql 'wm_queues'
@ install/db/Oracle8i/scheduler/saext_queue_admin/CreateQueue.sql

BEGIN

   -- en_event_status_change_v
   run_sql( ' CREATE OR REPLACE VIEW en_event_status_change_v AS '
         || ' SELECT e.event_id,e.event_time,e.event_type_id,e.data_tstamp,e.handled_tstamp, '
         || '    esc.status_message,esc.summary,esc.long_message, '
         || '    esc.start_time,esc.end_time,esc.log_file '
         || ' FROM en_event e, en_event_status_change esc, en_event_type et '
         || ' WHERE e.event_id = esc.event_id '
         || '    AND e.event_type_id = et.event_type_id '
         || '    AND et.name in '
         || '    ( '
         || '    ''SCHED_REPORT_GROUP_S'',''SCHED_REPORT_GROUP_F'',''BUSYHOUR_S'',''BUSYHOUR_F'', '
         || '    ''SUMMATION_S'',''SUMMATION_F'',''PARTMAINT_D_S'',''PARTMAINT_D_F'', '
         || '    ''PARTMAINT_W_S'',''PARTMAINT_W_F'',''PARTMAINT_M_S'',''PARTMAINT_M_F'', '
         || '    ''ANALYZE_S'',''ANALYZE_F'',''RGFP_S'',''RGFP_F'', '
         || '    ''SCENARIO_AD_S'',''SCENARIO_AD_F'',''SOFTALARM_S'',''SOFTALARM_F'', '
         || '    ''SUMMARY_CLEAN_S'',''SUMMARY_CLEAN_F'',''AUTOCLEAN_S'',''AUTOCLEAN_F'', '
         || '    ''BUSYHOUR_CLEAN_S'',''BUSYHOUR_CLEAN_F'',''EVENT_CLEAN_S'',''EVENT_CLEAN_F'', '
         || '    ''EXPECTATION_S'',''EXPECTATION_F'', '
         || '    ''SOFTALARM_S'', ''SOFTALARM_F'', '
         || '    ''AGGREGATOR_S'', ''AGGREGATOR_F'', '
         || '    ''SUMMARY_CLEAN_S'', ''SUMMARY_CLEAN_F'', '
         || '    ''AUTOCLEAN_S'', ''AUTOCLEAN_F'', '
         || '    ''BUSYHOUR_CLEAN_S'', ''BUSYHOUR_CLEAN_F'', '
         || '    ''EVENT_CLEAN_S'', ''EVENT_CLEAN_F'', '
         || '    ''EXPECTATION_S'', ''EXPECTATION_F'', '
         || '    ''SAEXT_PUSH_S'', ''SAEXT_PUSH_F'' '
         || '    ) '
         );

   -- sa_aggregator
   run_sql( ' ALTER TABLE sa_aggregator '
         || ' ADD '
         || ' Class CHAR(1) DEFAULT ''D'' NOT NULL ');

   run_sql( 'ALTER TABLE sa_aggregator '
         || ' ADD '
         || ' CONSTRAINT saext_ag_class_chk CHECK (class IN (''D'',''E'')) ');

   -- sa_time_range
   run_sql( ' ALTER TABLE sa_time_range '
         || ' ADD '
         || ' Class CHAR(1) DEFAULT ''D'' NOT NULL ');

   run_sql( 'ALTER TABLE sa_time_range '
         || ' ADD '
         || ' CONSTRAINT saext_tr_class_chk CHECK (class IN (''D'',''E'')) ');

   -- saext_message
   run_sql(' CREATE OR REPLACE TYPE saext_message AS OBJECT '
         || '   ( '
         || '   ThresholdName      VARCHAR2(32), '
         || '   Tech               VARCHAR2(4), '
         || '   NEType             VARCHAR2(20), '
         || '   DataDateTime       DATE, '
         || '   BSCName            VARCHAR2(32), '
         || '   SectorName         VARCHAR2(32), '
         || '   Vendor             VARCHAR2(32), '
         || '   LAC                VARCHAR2(5), '
         || '   CID                VARCHAR2(5), '
         || '   Origin             VARCHAR2(20), '
         || '   CurVal             NUMBER, '
         || '   MeanVal            NUMBER, '
         || '   SampleCount        NUMBER, '
         || '   StddevPct          NUMBER, '
         || '   KPIInternalTime    NUMBER, '
         || '   Severity           VARCHAR2(20), '
         || '   NetworkDomain      VARCHAR2(10), '
         || '   STATIC FUNCTION construct( '
         || '      ThresholdName      VARCHAR2 DEFAULT NULL, '
         || '      Tech               VARCHAR2 DEFAULT NULL, '
         || '      NEType             VARCHAR2 DEFAULT NULL, '
         || '      DataDateTime       DATE DEFAULT NULL, '
         || '      BSCName            VARCHAR2 DEFAULT NULL, '
         || '      SectorName         VARCHAR2 DEFAULT NULL, '
         || '      Vendor             VARCHAR2 DEFAULT NULL, '
         || '      LAC                VARCHAR2 DEFAULT NULL, '
         || '      CID                VARCHAR2 DEFAULT NULL, '
         || '      Origin             VARCHAR2 DEFAULT NULL, '
         || '      CurVal             NUMBER DEFAULT NULL, '
         || '      MeanVal            NUMBER DEFAULT NULL, '
         || '      SampleCount        NUMBER DEFAULT NULL, '
         || '      StddevPct          NUMBER DEFAULT NULL, '
         || '      KPIInternalTime    NUMBER DEFAULT NULL, '
         || '      Severity           VARCHAR2 DEFAULT NULL, '
         || '      NetworkDomain      VARCHAR2 DEFAULT NULL '
         || '   ) RETURN saext_message '
         || '   ) '
         );

   run_sql(' CREATE OR REPLACE TYPE BODY saext_message IS '
         || ' '
         || '   STATIC FUNCTION construct( '
         || '      ThresholdName      VARCHAR2 DEFAULT NULL, '
         || '      Tech               VARCHAR2 DEFAULT NULL, '
         || '      NEType             VARCHAR2 DEFAULT NULL, '
         || '      DataDateTime       DATE DEFAULT NULL, '
         || '      BSCName            VARCHAR2 DEFAULT NULL, '
         || '      SectorName         VARCHAR2 DEFAULT NULL, '
         || '      Vendor             VARCHAR2 DEFAULT NULL, '
         || '      LAC                VARCHAR2 DEFAULT NULL, '
         || '      CID                VARCHAR2 DEFAULT NULL, '
         || '      Origin             VARCHAR2 DEFAULT NULL, '
         || '      CurVal             NUMBER DEFAULT NULL, '
         || '      MeanVal            NUMBER DEFAULT NULL, '
         || '      SampleCount        NUMBER DEFAULT NULL, '
         || '      StddevPct          NUMBER DEFAULT NULL, '
         || '      KPIInternalTime    NUMBER DEFAULT NULL, '
         || '      Severity           VARCHAR2 DEFAULT NULL, '
         || '      NetworkDomain      VARCHAR2 DEFAULT NULL '
         || '   ) RETURN saext_message  '
         || 'IS '
         || '   BEGIN '
         || ' '
         || '   RETURN saext_message( '
         || '      ThresholdName, '
         || '      Tech, '
         || '      NEType, '
         || '      DataDateTime, '
         || '      BSCName, '
         || '      SectorName, '
         || '      Vendor, '
         || '      LAC, '
         || '      CID, '
         || '      Origin, '
         || '      CurVal, '
         || '      MeanVal, '
         || '      SampleCount, '
         || '      StddevPct, '
         || '      KPIInternalTime, '
         || '      Severity, '
         || '      NetworkDomain '
         || '   ); '
         || ' '
         || '   END; '
         || 'END; '
         );


   -- saext_seq
   run_sql(' CREATE SEQUENCE saext_seq '
         || '    START WITH 1 '
         || '    INCREMENT BY 1 '
         || '    MAXVALUE 9999 '
         || '    MINVALUE 1 '
         || '    CYCLE '
         || '    CACHE 100 '
         || '    NOORDER '
         );

   -- saext_log
   run_sql(' CREATE GLOBAL TEMPORARY TABLE saext_log '
         || '( '
         || '  tstamp    DATE NOT NULL, '
         || '  msg       VARCHAR2(512) '
         || ') '
         || 'ON COMMIT DELETE ROWS   '
         );

   -- Create the queue ... package has its own exception handling
   run_sql(' BEGIN '
         || ' saext_queue_admin.make_queue(''saext_q'', '
         || '       ''saext_qt'', '
         || '       ''saext_message''); '
         || 'END; '
         );

run_sql( ' CREATE TABLE saext_kpi_tab '
|| '( '
|| '   tstamp           DATE    NOT NULL, '
|| '   sa_id            INTEGER NOT NULL, '
|| '   instance_id              INTEGER NOT NULL, '
|| '   correlation_task_id  INTEGER DEFAULT 0 NOT NULL, '
|| '   exclude          CHAR(1) DEFAULT ''N'' NOT NULL, '
|| '   value            FLOAT           NOT NULL, '
|| '   CONSTRAINT pk_saext_kpi_tab PRIMARY KEY (tstamp, sa_id, instance_id), '
|| '   CONSTRAINT exclude_chk CHECK (exclude IN (''N'', ''Y'')) '
|| ') '
|| 'ORGANIZATION INDEX '
|| 'PARTITION BY RANGE (tstamp) '
|| '( '
|| '   PARTITION P2008060100 VALUES LESS THAN (TO_DATE(''20080601'', ''YYYYMMDD'')) '
|| ') '
|| 'TABLESPACE traffic_large MONITORING '
);

run_sql( ' CREATE TABLE saext_alarm '
|| '( '
|| '   task_id          INTEGER NOT NULL, '
|| '   tstamp           DATE    NOT NULL, '
|| '   instance_id      INTEGER NOT NULL  '
|| ') '
|| 'TABLESPACE traffic_large '
);

run_sql( ' CREATE INDEX saext_alarm_idx on saext_alarm ( task_id, tstamp) '
);

run_sql( 'CREATE GLOBAL TEMPORARY TABLE saext_exclude '
|| '( '
|| '   instance_id		INTEGER	 NOT NULL, '
|| '   sa_id                INTEGER  NOT NULL, '
|| '   value                NUMBER   NOT NULL, '
|| '   sd                   NUMBER   NOT NULL, '
|| '   aver		        NUMBER   NOT NULL, '
|| '   samples		INTEGER	 NOT NULL '
|| ') '
|| 'ON COMMIT DELETE ROWS ' );

END;
/
