---------------------------------------------------------------------------
--
-- Licensed Materials - Property of IBM
-- 5724-T05,5724-T06
--
-- (C) Copyright IBM Corp. 2003,2008. All Rights Reserved.
--
-- US Government Users Restricted Rights - Use, duplication or
-- disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
---------------------------------------------------------------------------
-- (#) schema_patch.sql BL_core_schema_8.0.5_8.0.5.5.06_20081022
--

begin

 -- SEAde69411: Part maint parallelism
 --
   run_sql( ' ALTER TABLE part_tables ADD '
         || ' ( '
         || '   move_parallelism_degree number(2) CONSTRAINT part_tables_move_par_ck '
         || '      CHECK (nvl(move_parallelism_degree,0) >= 0), '
         || '   stats_parallelism_degree number(2) CONSTRAINT part_tables_stats_par_ck '
         || '      CHECK (nvl(stats_parallelism_degree,0) >= 0) '
         || ' ) ' );

   run_sql( ' CREATE TABLE part_tablespaces '
         || ' ( '
         || '   tablespace_name  VARCHAR2(30)     NOT NULL, '
         || '   move_parallelism_degree number(2) CONSTRAINT part_tablespaces_move_par_ck '
         || '      CHECK (nvl(move_parallelism_degree,0) >= 0), '
         || '   stats_parallelism_degree number(2) CONSTRAINT part_tablespaces_stats_par_ck '
         || '      CHECK (nvl(stats_parallelism_degree,0) >= 0), '   
         || '   CONSTRAINT pk_part_tablespaces PRIMARY KEY (tablespace_name) '
         || ' ) '
         || ' TABLESPACE wm_flexpm ' );

   run_sql( ' ALTER TABLE part_task '
         || ' ADD ( move_parallelism_degree number(2), '
         || '       stats_parallelism_degree number(2) ) ' );

END;
/
commit;
