---------------------------------------------------------------------------
--
-- Licensed Materials - Property of IBM
-- 5724-T05,5724-T06
--
-- (C) Copyright IBM Corp. 2003,2008. All Rights Reserved.
--
-- US Government Users Restricted Rights - Use, duplication or
-- disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--
---------------------------------------------------------------------------
-- (#) trigger_patch.sql BL_core_schema_8.0.5_8.0.5.5.06_20081022
--
BEGIN

   run_sql( ' Create OR Replace Trigger WMN_Instance_Context_Tr_AIUD ' 
         || '     AFTER INSERT OR UPDATE OR DELETE ON WMN_INSTANCE_CONTEXT '
         || '         FOR EACH ROW '
         || ' Begin '
         || '    IF INSERTING OR UPDATING THEN '
         || '       IF (:new.context_id=wm_scenario.get_context) THEN '
         || '           wm_scenario.Entity_Alert( :new.Entity_ID ); '
         || '       END IF; '
         || '    ELSE '
         || '       IF (:old.context_id=wm_scenario.get_context) THEN '
         || '           wm_scenario.Entity_Alert( :old.Entity_ID ); '
         || '       END IF; '
         || '    END IF; ' 
         || ' End; ');

   
   run_sql( ' CREATE OR REPLACE TRIGGER en_event_status_change_trigger '
         || '    INSTEAD OF INSERT OR DELETE ON en_event_status_change_v '
         || '    FOR EACH ROW '
         || '    DECLARE '
         || '    event_id_new INTEGER; '
         || ' BEGIN ' 
         || '    IF (inserting) THEN '
         || '       if :new.event_id is null '
         || '       then '
         || '          select en_event_seq.nextval into event_id_new from dual; '
         || '       else '
         || '          event_id_new := :new.event_id; '
         || '       end if; '
         || '  '
         || '       INSERT INTO en_event(event_id, event_time, event_type_id, data_tstamp) '
         || '          VALUES (event_id_new,nvl(:new.event_time, sysdate),:new.event_type_id, '
         || '          :new.data_tstamp); '
         || '  '
         || '       INSERT INTO en_event_status_change(event_id,status_message,summary, '
         || '          long_message,log_file,start_time,end_time) '
         || '          VALUES (event_id_new, :new.status_message, :new.summary,:new.long_message, '
         || '          :new.log_file,:new.start_time,:new.end_time); '
         || '  '
         || '    ELSIF (deleting) THEN '
         || '  '
         || '       DELETE FROM en_event WHERE event_id = :old.event_id; '
         || '  '
         || '    END IF; '
         || '  '
         || ' END; ');


   run_sql( ' CREATE OR REPLACE TRIGGER sa_softalarm_bu '
         || ' BEFORE UPDATE '
         || ' ON sa_softalarm '
         || ' FOR EACH ROW '
         || ' DECLARE '
         || '    l_client_info VARCHAR2(64); '
         || ' BEGIN '
         || '    IF ( :old.time_range_id IS NOT NULL '
         || '         AND :old.time_range_id = 6 '
         || '         AND ( :new.time_range_id IS NULL  '
         || '               OR :new.time_range_id != 6 ) ) THEN '
         || '  '
         || '       DBMS_APPLICATION_INFO.READ_CLIENT_INFO( l_client_info ); '
         || '  '
         || '       IF ( l_client_info IS NULL OR l_client_info != ''SAEXT'' ) THEN '
         || '          RAISE_APPLICATION_ERROR( -20085, ''The client is not compatible with SAEXT. Please update your client.'' ); '
         || '       END IF; '
         || '  '
         || '    END IF; '
         || '  '
         || ' END; ');

END;
/

